var w,t
char c$,ctst$
index i,j,k
print "This program tests if the Basic 1000d runs on an emulator as on a true ST."
print "If OK, the time it would take on an ST will be printed at the end."
if 1
testing numbers1
testing numbers2
testing numeric1
testing numeric2
testing numeric3
testing primenumber1
testing primenumber2
testing factoringinteger1
testing factoringinteger2
testing modularpower
testing determinant
endif
print "Test passed correctly. Total ST time="&timer&" s"
message " Test run ended   |No error detected"
stop
testing:procedure
ctst$=
msec=mtimer
@1
msec=mtimer-msec
print "******* ";justl$("@1",15);" *****  ";
if msec>10000
print msec\1000;" s"
else
print msec;" ms"
endif
ift ctst$<>"" print ctst$
return
numbers2:procedure
push precision2
precision 20
ift appr(pi,31)<> 104348/33215 ???
ctst$="appr(pi,31)=  104348/33215"
precision2 pop
return

numbers1:procedure
w=sum(i=0,28 of 1/ppwr(i))
ift w<>828772446866981044847857913441/304888344611713860501504000000 ???
ctst$="computation of sum(i=0,28 of 1/ppwr(i))"
return
modularpower:procedure
ift mdpwre(721580,5^6789,1234577)<>2 ???
ctst$="721580^(5^6789) mod 1234577 =2"
return
primenumber2:procedure
ift prtst(1111111111111111111)<>-1 ???
ctst$="1111111111111111111 is prime"
return
primenumber1:procedure
ift prime(10^19)<>10^19+51 ???
ctst$=10^19+51&" is prime"
return
numeric3:procedure
push format
push precision2
precision 30
format 30
ctst$="2^(1/3)="&2^(1/3)
ift ctst$<>"2^(1/3)=  1.25992104989487316476721060728~" ???
precision2 pop
format pop
return

numeric2:procedure
push precision2
precision 100
ctst$="sin(2)="&sin(2)
ift ctst$<>"sin(2)=  0.9092974268256816953960198659117448427022549714478902683789730115309673015407835446201266889249593803~" ???
precision2 pop
return

numeric1:procedure
push precision2
precision 25
ctst$="log(10)="&log(10)
ift ctst$<>"log(10)=  0.2302585092994045684017991~ E+1" ???
precision2 pop
return

factoringinteger2:procedure
print_dev "mem:",ctst$
Tbrison 2^67-1
close  #102
c$="  147573952589676412927=  193707721 * 761838257287"
ift (left$(ctst$,50)<>c$) ???
return

factoringinteger1:procedure
c$=prfact$((2^39+1)/9)
ift ("  2731 * 22366891"<>c$) ???
ctst$=(2^39+1)/9&" ="&c$&
c$=prfact$(2^43+1)
ift ("  3 * 2932031007403"<>c$) ???
cadd ctst$, 2^43+1," =",c$
return
determinant:procedure
local var D(6,6)
local lit a,b,c,d,e,f
D(1,1)=d
D(1,2)=(d+e-c)/2
D(1,3)=(d+f-b)/2

D(2,1)=(d+e-c)/2
D(2,2)=e
D(2,3)=(e+f-a)/2

D(3,3)=f
D(3,1)=(d+f-b)/2
D(3,2)=(e+f-a)/2
for i=1,3
for j=1,3
D(i+3,j+3)=D(i,j)
next j,i
w=16*det(D,6)
factor
w=formf(w)
ctst$="6 x 6 symbolic determinant="&w
ift factorn(w)-2 ???
ift factorp(w,1)-1 ???
t=-factorp(w,2)+f^2*c -f*e*c -f*e*b +f*e*a -f*d*c +f*d*b -f*d*a +f*c^2 -f*c*b -f*c*a +e^2*b +e*d*c -e*d*b -e*d*a -e*c*b +e*b^2 -e*b*a +d^2*a -d*c*a -d*b*a +d*a^2 +c*b*a
ift t ???
ift factore(w,1)-1 ???
ift factore(w,2)-2 ???
develop
t=w- [f^2*c -f*e*c -f*e*b +f*e*a -f*d*c +f*d*b -f*d*a +f*c^2 -f*c*b -f*c*a +e^2*b +e*d*c -e*d*b -e*d*a -e*c*b +e*b^2 -e*b*a +d^2*a -d*c*a -d*b*a +d*a^2 +c*b*a]^2
ift t ???
return





Tdabord_prfact:print n;"=  ";
local var x
np=prfact(n,2^16)
l=polymn(np)
if l<>1
for i=1,l-1
x=polym(np,i)
print justl$(norm(x));
k=deg(x,phantom)
if k=1
print " * ";
else
print "^";justl$(k);" * ";
endif
next i
endif
x=polym(np,l)
n=norm(x)
k=deg(x,phantom)
ift n>2^32 ift prtst(n)=0 return
if k=1
print justl$(n)
else
print justl$(n);"^";justl$(k)
endif
n=1
return
Tbrison:procedure(n)
char c$
index k,pm
Tdabord_prfact
ift n=1 return
pm=661
if @0=2
k=@2
ift k<1 k=Tkmult
else
k=1
ift n>2^79 k=Tkmult
endif
do
c$=Tbrison_1(n,k,pm)
ift len(c$) exit
k=k+1
loop
print c$
return
Tkmult:function
push precision2
precision 10
local index i,j,k,m,km
m=200
km=23
local index p(m)
local var y,F,Fm,np
j=1
for i=1,m
j=prime(j+1)
p(i)=j
ift j>pm exit
next i
m=i-1
ift p(m)<>pm err_Tkmult
y=phantom
for k=1,km
for i=1,polymn(y)
ift deg(polym(y,i))>1 goto Tkmult_1
next i
np=k*n
select modr(np,8)
case =1
F=4~/3
case =5
F=2~/3
case others
F=1~/3
endselect
F=F*log(2)-log(k)/2
for i=2,m
if modr(k,p(i))
ift legendre(np,p(i))=1 F=F+2*p(i)/(p(i)^2-1)*log(p(i))
else
F=F+log(p(i))/(1+p(i))
endif
next i
if F>Fm
value=k
Fm=F
endif
Tkmult_1:y=prfact(k+1)
next k
precision2 pop
return
Tbrison_1:function$(n,index k,pm)
index i,mm,P0,jk,j,s,kf
var np,d,r,rp,u,up,v,vp,P,Pp,a
var t,tf,l,pc,xx,y
lit z
mm=2000
P0=32749
index*16 b(P0)
var E(mm),e,x(mm),iter
P0=min(P0,pm*prime(pm+1)-1)
b(0)=-1
copy b(0),P0,1,b(1),1
iter=0
jk=0
d=k*n
r=intsqr(d)
rp=2*r
u=rp
up=rp
v=1
vp=d-r^2
P=r
Pp=1
a=0
s=0
Tbrison_2:vadd vp,a*(up-u)
exg v,vp
a=divr(u,v)
up=u
u=rp-modr(u,v)
s=1-s
t=v
e=s
ift t=1 goto Tbrison_3
tf=prfact(t,pm)
l=polymn(tf)
ift norm(polym(tf,l))>P0 goto Tbrison_6
for i=l,1
pc=polym(tf,i)
vadd e,deg(pc)*z^norm(pc)
next i
Tbrison_3:xx=P
Tbrison_4:pc=mod(e,2)
kf=deg(pc)
ift kf=0 ift pc=0 goto Tbrison_5
if b(kf)>=0
i=b(kf)
xx=modr(xx*x(i),n)
e=e+E(i)
goto Tbrison_4
else
b(kf)=jk
x(jk)=xx
E(jk)=e
jk=jk+1
goto Tbrison_6
endif
Tbrison_5:y=1
for i=1,polymn(e)
pc=polym(e,i)
j=deg(pc)
ift j y=modr(y*mdpwre(j,norm(pc)/2,n),n)
next i
endif
ift xx+y=n goto Tbrison_6
ift xx=y goto Tbrison_6
np=gcdr(xx-y,n)
'print "(iter=";iter;"  jk=";jk;"  timer=";timer;")   ";
push$ ""," * "
for i=1,2
if prtst(np)
cadd value,justl$(np)&pop$
else
cadd value,"("&justl$(np)&")"&pop$
endif
np=n/np
next i
return
Tbrison_6:iter=iter+1
ift v=1 return'chec_Tbrison
Pp=modr(a*P+Pp,n)
exg P,Pp
goto Tbrison_2
-----------------------------------------------------
