'
' rsolution numrique d'un stystme de m quations  n inconnues et
'  n conditions sur les inconnues

' c_fonctions :
' nsgeq(m,n,eq,z {,cnd})
' nsgeqd(m,n,eq0,eq1,...,eqm,z0,z1,...,zn {,cnd0,...,cndm})
' nsgeqe(m,n,eq0,eq1,...,eqm,z0,z1,...,zn {,cnd0,...,cndm})
'
'
'
' VOIR MANUEL DU BASIC PAGES 359-360
'
' ces noms des c_fonctions rajoutent "n" devant les noms pages 359-360
' la donne des q et inconnues y est identique.
' les programmes sont une simple variation.
' Ici les quations d'ordre >2 sont rsolues numriquement (racines relles)
'  l'aide de la procdure "zero"
' Les sorties vrifient les conditiions cndk, sont exactes ou flottantes.
' si zk est flottant, les valeurs suivantes seront aussi en flottant
' meme si elles taient exactes
'
' donne des conditions (s'il y en a):
' cnd0, ..., cndm sont des noms de v-fonctions;
' on peut omettre des noms  la fin, par exemple donner que cnd0
' cnd0(vz0) renvoi 0 (false) si z0=vz0 (exact ou flottant) ne convient pas
'           et une valeur diffrente de 0 (true) si elle convient.
' cnd1(vz0,vz1) renvoi 0 (false) si z0=vz0, z1=vz1 ne convient pas
'           et une valeur diffrente de 0 (true) si elle convient.
' cndn(vz0,...,vzn) renvoi 0 (false) si z0=vz0, ..., zn=vzn ne convient pas
'           et une valeur diffrente de 0 (true) si elle convient.

'
'
'
'







' EXEMPLE
' problme de trouver un carr magique 3x3 en surfaces

S_VAR 2000
S_PRO 20000
pack 400000
'cas dep=3
eq1=7*a^2*b -210*a^2 -7*a*b^2 +50*a*b +17400*a +210*b^2 -20400*b +288000
eq2=7*b^2*c -210*b^2 -7*b*c^2 -30*b*c +19800*b +210*c^2 -18000*c +54000
eq3=7*c^2*d -210*c^2 -7*c*d^2 -110*c*d +22200*c +210*d^2 -15600*d -180000
eq4=7*a^2*d -210*a^2 -7*a*d^2 +190*a*d +13200*a +210*d^2 -24600*d +414000
var eqt(3),z(3)
eqt(0)=eq1
eqt(1)=eq2
eqt(2)=eq3
eqt(3)=eq4
z(0)=a
z(1)=c
z(2)=b
z(3)=d
cote=90
'c$=nsgeqe(3,3,eq1,eq2,eq3,eq4,a,c,b,d)
c$=nsgeqe(3,3,eq1,eq2,eq3,eq4,a,c,b,d,conda,condac,condacb,condacbd)
cadd c$,
cadd c$,
cadd c$,"----------------------------------------",
cadd c$,"Comparaison avec la rsolution par sgeqe",
cadd c$,"----------------------------------------",

cadd c$,sgeqe(3,3,eq1,eq2,eq3,eq4,a,c,b,d)
'c$=nsgeq(3,3,eqt,z,conda,condac,condacb,condacbd)
res:print /a/c$
stop
condacbd:function(a,c,b,d)
ift d<0 return
ift d>2*cote/3 return
ift b>cote/3+d return
ift d>cote/3+b return
value=-1
return
condacb:function(a,c,b)
ift b<0 return
ift b>2*cote/3 return
value=-1
return
condac:function(a,c)
ift c<0 return
ift c>2*cote/3 return
ift a>cote/3+c return
ift c>cote/3+a return
value=-1
return
conda:function(a)
ift a<0 return
ift a>2*cote/3 return
value=-1
return
endif


nsgeqm:procedure(char cp)
print cp
cadd value,cp
return
nsgeqe:function$
local datai @2 index ii,ii0 char chx
chx="Rsolution numrique en"
ii0=@1+4
for ii=ii0,ii0+ii
cadd chx,@ii
next ii
nsgeqm chx&" du systme"
for ii=0,@1
nsgeqm @(3+ii)&"= 0"
next ii
ii=@1+@2+5
if ii<=@0
chx="telles que les fonctions (conditions) "
cadd chx,"@ii(",justl$(@ii0),")"
ii=ii+1
if ii<=@0
cadd chx,", @ii(",justl$(@ii0),",",justl$(@(ii0+1)),")"
ii=ii+1
if ii<=@0
for ii=ii,@0
cadd chx,", @ii(",justl$(@ii0),",",justl$(@(ii0+1)),",...)"
next ii
endif
endif
endif
nsgeqm chx&" soient vraies (valeur <>0)."
nsgeqm "Solution"
nsgeqd:function$
local datai @1+@2+4 index nsgeqi
for nsgeqi=3,nsgeqi
push @nsgeqi
next nsgeqi
push @1+@2+5
goto nsgeq00
nsgeq:function$(index nsgeqm,nsgeqn)
local index nsgeqi
for nsgeqi=0,nsgeqm
push @3(nsgeqi)
next nsgeqi
for nsgeqi=0,nsgeqn
push @4(nsgeqi)
next nsgeqi
push 5
nsgeq00:nolocal
argument(index m,n)
local index p,nsgeqa,p1,p2,n0,vze(n),nbsol
local char cz,cp,cnd(n)
local var eq(m),z(n),vz(n),pc,eq1(n)
p1=pop
cz="eq(p)=red(num(pop)"&conc$(p=0,n of ",z("&justl$(p)&")")&")"
for p=0,n
z(p)=pop
next p
for p=0,m
xqt cz
next p
for p=n,0
if p1<=@0
cnd(p)="pc=@p1(vz(" & justl$(n)&")"
if p<=n-1
for p2=n-1,p
cadd cnd(p),",vz(",justl$(p2),")"
next p2
endif
cadd cnd(p),")"
else
cnd(p)="pc=-1"
endif
p1=p1+1
next p
p=0
goto nsgeq01
nsgeq1:procedure(index p,m,n var eq(@2),z(@3))
nsgeq01:local var wq
local index i,j,k,jm,dm,d
nsgeq10:for i=p,n
j=-1
if p<=m
for jm=p,m
d=deg(eq(jm),z(i))
if d
if j=-1
nsgeq11:dm=d
j=jm
else
ift d=dm ift mlen(eq(jm))<mlen(eq(j)) goto nsgeq11
ift d<dm goto nsgeq11
endif
endif
next jm
endif
if j=-1
nsgeqm "L'inconnue"&z(i)&" est arbitraire"
if i
for j=0,i-1
cz="eq(j)=red(eq(j)"
for k=0,n
ift k<>i cz=cz&",z(",justl$(k),")"
next k
xqt cz&")"
next j
endif
n=n-1
nonext i
ift i>n goto nsgeq15
for i=i,n
z(i)=z(i+1)
cnd(i)=cnd(i+1)
next i
goto nsgeq10
else
ift j<>p exg eq(j),eq(p)
if p<m
cz=conc$(k=n,i of ",z("&justl$(k)&")")&")"
for j=p+1,m
wq=gcd(eq(j),eq(p))
if wq=1
next j
else
nonext i
vdive eq(p),wq
vdive eq(j),wq
xqt "d=deg(eq(p)"&cz
ift d=0 goto nsgeq12
xqt "d=deg(eq(j)"&cz
ift d=0 goto nsgeq12
nsgeqcas
push$ cz
nsgeqm "Facteur commun F"&cz&"="&wq&cz&".a. Cas F"&cz&"<>0"
xqt "nsgeq1 p,m,n",conc$(k=m,0 of ",eq("&k&")"),conc$(k=n,0 of ",z("&k&")")
cz=pop$
nsgeqm cz&".b. Cas F"&cz&"=0"
goto nsgeq13
nsgeq12:nsgeqm "Equations non indpendantes"
nsgeq13:eq(p)=wq
m=m-1
ift j>m goto nsgeq10
for j=j,m
eq(j)=eq(j+1)
next j
goto nsgeq10
endif
endif
if p<m
for j=p+1,m
ift deg(eq(j),z(i)) xqt "eq(j)=red(elim(eq(j),eq(p),z(i))"&cz
next j
endif
endif
p=p+1
next i
nsgeq15:n1=n
ift p>m goto nsgeq17
nsgeqm "Pas de solution"
return
nsgeqcas:nsgeqa=nsgeqa+1
cz=justl$(nsgeqa)
return
nsgeqsortie:procedure(index n,var eq(@1))
nsgeq17:local index d1,d2
d2=deg(eq(n),z(n))
ift d2=0 return
local var T(d2),M(d2)
zero eq(n),T,M,d2,1
ift d2=0 return
for d1=1,d2
vz(n)=T(d1)
xqt cnd(n)
ift pc=0 goto nsgeq19
vze(n)=0
if exactp(vz(n))
ift n=n1 vze(n)=-1
ift n<n1 ift vze(n+1) vze(n)=-1
endif
ift vze(n)=0 vz(n)=appr(vz(n))
if n
cz="nsgeqsortie "& n-1
for i=n-1,0
eq1(i)=subs(eq(i),z(n)=vz(n))
cadd cz,",eq1(",justl$(i),")"
next i
test:
xqt cz
else
nbsol=nbsol+1
nsgeqm "solution"&nbsol
for i=n1,0
cz= z(i)&"="
if vze(i)
cadd cz, vz(i)
else
cadd cz, float(vz(i))
endif
nsgeqm cz
next i
endif
nsgeq19:next d1
return
